/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.cortesias;

import com.rjconsultores.ventaboletos.entidad.GrupoCortesia;
import com.rjconsultores.ventaboletos.entidad.TipoCortesia;
import com.rjconsultores.ventaboletos.service.GrupoCortesiasService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoCortesia;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Shiro
 */
@Controller("busquedaTipoCortesiaController")
@Scope("prototype")
public class BusquedaTipoCortesiaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoCortesia> plwTipoCortesia;
    @Autowired
    private GrupoCortesiasService grupoCortesiaService;
    private List<GrupoCortesia> grupoCortesiaList;
    private MyListbox tipoCortesiaList;
    private Paging pagingtipoCortesia;
    private Textbox txtNome;
    private Combobox cmbGrupoCortesia;

    public Paging getPagingtipoCortesia() {
        return pagingtipoCortesia;
    }

    public void setPagingtipoCortesia(Paging pagingtipoCortesia) {
        this.pagingtipoCortesia = pagingtipoCortesia;
    }

    public PagedListWrapper<TipoCortesia> getPlwTipoCortesia() {
        return plwTipoCortesia;
    }

    public void setPlwTipoCortesia(PagedListWrapper<TipoCortesia> plwTipoCortesia) {
        this.plwTipoCortesia = plwTipoCortesia;
    }

    public MyListbox getTipoCortesiaList() {
        return tipoCortesiaList;
    }

    public void setTipoCortesiaList(MyListbox tipoCortesiaList) {
        this.tipoCortesiaList = tipoCortesiaList;
    }

    public GrupoCortesiasService getGrupoCortesiaService() {
        return grupoCortesiaService;
    }

    public void setGrupoCortesiaService(GrupoCortesiasService grupoCortesiaService) {
        this.grupoCortesiaService = grupoCortesiaService;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Combobox getCmbGrupoCortesia() {
        return cmbGrupoCortesia;
    }

    public void setCmbGrupoCortesia(Combobox cmbGrupoCortesia) {
        this.cmbGrupoCortesia = cmbGrupoCortesia;
    }

    public List<GrupoCortesia> getGrupoCortesiaList() {
        return grupoCortesiaList;
    }

    public void setGrupoCortesiaList(List<GrupoCortesia> grupoCortesiaList) {
        this.grupoCortesiaList = grupoCortesiaList;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoCortesia(new TipoCortesia());

    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        grupoCortesiaList = grupoCortesiaService.obtenerTodos();
        super.doAfterCompose(comp);

        tipoCortesiaList.setItemRenderer(new RenderTipoCortesia());
        tipoCortesiaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoCortesia tc = (TipoCortesia) tipoCortesiaList.getSelected();
                verTipoCortesia(tc);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verTipoCortesia(TipoCortesia tc) {
        if (tc == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tipoCortesia", tc);
        args.put("tipoCortesiaList", tipoCortesiaList);

        openWindow("/gui/cortesias/editarTipoCortesia.zul",
                Labels.getLabel("editarTipoCortesiaController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TipoCortesia> claseServicioBusqueda =
                new HibernateSearchObject<TipoCortesia>(TipoCortesia.class, pagingtipoCortesia.getPageSize());

        Comboitem cbi = cmbGrupoCortesia.getSelectedItem();
        GrupoCortesia gc = null;
        if (cbi != null) {
            gc = (GrupoCortesia) cbi.getValue();
            claseServicioBusqueda.addFilterEqual("grupoCortesia", gc);
        }

        claseServicioBusqueda.addFilterLike("desctipo", "%" + txtNome.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);

        claseServicioBusqueda.addSortAsc("desctipo");

        plwTipoCortesia.init(claseServicioBusqueda, tipoCortesiaList, pagingtipoCortesia);

        if (tipoCortesiaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("editarTipoCortesiaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
